/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 */

package org.ow2.frascati.factory.core.instance.assembly;

import org.eclipse.stp.sca.Composite;
import org.objectweb.fractal.fraclet.annotations.Component;
import org.objectweb.fractal.fraclet.annotations.Requires;
import org.ow2.frascati.factory.core.instance.NotSupportedException;
import org.ow2.frascati.factory.core.instance.binding.BindingException;
import org.ow2.frascati.factory.core.instance.component.ScaComponent;
import org.ow2.frascati.factory.core.instance.implementation.ImplementationException;
import org.ow2.frascati.factory.core.instance.interfaces.InterfaceException;



/**
 * Create assembly instance
 * 
 * @author <a href="mailto:damien.fournier@inria.fr">Damien Fournier</a>
 * @version $Revision$
 */

@Component
public class ScaAssemblyImpl implements ScaAssembly {

  /**
   * Logger for this class 
   */

  java.util.logging.Logger log = java.util.logging.Logger
      .getLogger(ScaAssemblyImpl.class.getCanonicalName());

  /**
   * The required component builder component
   */

  @Requires(name = "components")
  ScaComponent scaComponent;

  /*
   * (non-Javadoc)
   * 
   * @see org.ow2.frascati.factory.core.instance.AssemblyBuilder#create(org.eclipse.stp.sca.DocumentRoot)
   */

  public org.objectweb.fractal.api.Component create(Composite composite) throws ImplementationException, NotSupportedException, BindingException, InterfaceException {

    org.objectweb.fractal.api.Component assemblyComponent = null;

    log.fine("Building composite " + composite.getName());

    // Create assembly
    assemblyComponent = scaComponent.create(composite);

    log.fine("Composite " + composite.getName() + " successfully created \n");

    return assemblyComponent;

  }
  

}
