/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 */

package org.ow2.frascati.factory.core.instance.binding;

import java.util.Map;

import org.eclipse.stp.sca.Composite;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.fraclet.annotations.Interface;
import org.ow2.frascati.factory.core.instance.NotSupportedException;


@Interface(name = "binding")
public interface ScaBindingProcess {
  
  /**
   * Create bindings between components into the assembly, and,
   * create bindings between components and the assembly itself. 
   * 
   * @param modelComposite - The assembly according to the model definition
   * @param fractalComposite - The assembly according to fractal
   * @param map 
   * @throws NotSupportedException 
   * @throws BindingException 
   */
  
  public void processBinding(Composite modelComposite, org.objectweb.fractal.api.Component fractalComposite, Map<String, Component> map ) throws NotSupportedException, BindingException;

}
