/***
 * OW2 FraSCAti Assembly Factory
 * Copyright (C) 2008-2009 INRIA, USTL
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: frascati@ow2.org 
 *
 * Author: Damien Fournier
 */

package org.ow2.frascati.factory.core.instance.interfaces;

import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.fraclet.annotations.Interface;
import org.ow2.frascati.factory.core.instance.NotSupportedException;

/**
 * Create interface from java interface
 * 
 * @author <a href="mailto:damien.fournier@inria.fr">Damien Fournier</a>
 * @version $Revision$
 */

@Interface(name = "component-interface")
public interface ScaInterface {

  /**
   * Create interface type
   * 
   * @param scaInterface -
   *          Interface definition
   * @return The resulting fractal interface type
   * @throws NotSupportedException 
   * @throws InterfaceException 
   */

  public InterfaceType create(org.eclipse.stp.sca.Interface scaInterface) throws NotSupportedException, InterfaceException;
  
  
  /**
   * Get interface type 
   * 
   * @return EObject ID from the SCA model
   */
  
  public int getInterfaceID();

}
